#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void ADC_init(void)
{
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (1 << ADPS0) | (1 << ADPS1) | (1 << ADPS2) | (1 << ADSC);
}

uint16_t ADC_get(uint8_t channel)
{
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
}

int main()
{
    char line1[17], line2[17];
    static char empty_line[17] = "                ";
    LCD_init();
    ADC_init();
    //lcd_contrast(0x30);

    while (1) {
	float value = 0;

	for (int i = 0; i < 50; i++)
	    value += ADC_get(0);

	value /= 50;

	if (value < 100) {
	    sprintf(line1, "OK");
	    strcpy(line2, empty_line);
	} else if (value >= 100 && value < 200) {
	    sprintf(line1, "SUB LIMITA");
        strcpy(line2, empty_line);
	} else if (value >= 200 && value < 400) {
	    sprintf(line1, "PESTE MEDIE");
	} else {
	    sprintf(line1, "ALCOOLEMIE MAXIMA");
        strcpy(line2, empty_line);
	}

	LCD_printAt(0, empty_line);
	LCD_printAt(0, line1);

	LCD_printAt(0x40, empty_line);


	_delay_ms(100);
    }

    return 0;
}
